/**
 */
package earthnewmedia.model.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import earthnewmedia.model.util.ModelAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support
 * Viewers. The adapters generated by this factory convert EMF adapter
 * notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}. The
 * adapters also support Eclipse property sheets. Note that most of the adapters
 * are shared among multiple instances. <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class ModelItemProviderAdapterFactory extends ModelAdapterFactory
        implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
    /**
     * This keeps track of the root adapter factory that delegates to this adapter
     * factory. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected ComposedAdapterFactory parentAdapterFactory;

    /**
     * This is used to implementO
     * {@link org.eclipse.emf.edit.provider.IChangeNotifier}. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected IChangeNotifier changeNotifier = new ChangeNotifier();

    /**
     * This keeps track of all the supported types checked by
     * {@link #isFactoryForType isFactoryForType}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected Collection<Object> supportedTypes = new ArrayList<Object>();

    /**
     * This constructs an instance. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public ModelItemProviderAdapterFactory() {
        supportedTypes.add(IEditingDomainItemProvider.class);
        supportedTypes.add(IStructuredItemContentProvider.class);
        supportedTypes.add(ITreeItemContentProvider.class);
        supportedTypes.add(IItemLabelProvider.class);
        supportedTypes.add(IItemPropertySource.class);
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link earthnewmedia.model.User} instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected UserItemProvider userItemProvider;

    /**
     * This creates an adapter for a {@link earthnewmedia.model.User}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createUserAdapter() {
        if (userItemProvider == null) {
            userItemProvider = new UserItemProvider(this);
        }

        return userItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link earthnewmedia.model.Credentials} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected CredentialsItemProvider credentialsItemProvider;

    /**
     * This creates an adapter for a {@link earthnewmedia.model.Credentials}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createCredentialsAdapter() {
        if (credentialsItemProvider == null) {
            credentialsItemProvider = new CredentialsItemProvider(this);
        }

        return credentialsItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link earthnewmedia.model.MemberAttribute} instances. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected MemberAttributeItemProvider memberAttributeItemProvider;

    /**
     * This creates an adapter for a {@link earthnewmedia.model.MemberAttribute}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createMemberAttributeAdapter() {
        if (memberAttributeItemProvider == null) {
            memberAttributeItemProvider = new MemberAttributeItemProvider(this);
        }

        return memberAttributeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link earthnewmedia.model.Library} instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected LibraryItemProvider libraryItemProvider;

    /**
     * This creates an adapter for a {@link earthnewmedia.model.Library}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createLibraryAdapter() {
        if (libraryItemProvider == null) {
            libraryItemProvider = new LibraryItemProvider(this);
        }

        return libraryItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link earthnewmedia.model.LibraryItem} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected LibraryItemItemProvider libraryItemItemProvider;

    /**
     * This creates an adapter for a {@link earthnewmedia.model.LibraryItem}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createLibraryItemAdapter() {
        if (libraryItemItemProvider == null) {
            libraryItemItemProvider = new LibraryItemItemProvider(this);
        }

        return libraryItemItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link earthnewmedia.model.Comment} instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected CommentItemProvider commentItemProvider;

    /**
     * This creates an adapter for a {@link earthnewmedia.model.Comment}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createCommentAdapter() {
        if (commentItemProvider == null) {
            commentItemProvider = new CommentItemProvider(this);
        }

        return commentItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link earthnewmedia.model.ArticleMetadata} instances. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected ArticleMetadataItemProvider articleMetadataItemProvider;

    /**
     * This creates an adapter for a {@link earthnewmedia.model.ArticleMetadata}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createArticleMetadataAdapter() {
        if (articleMetadataItemProvider == null) {
            articleMetadataItemProvider = new ArticleMetadataItemProvider(this);
        }

        return articleMetadataItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link earthnewmedia.model.ImageMetadata} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected ImageMetadataItemProvider imageMetadataItemProvider;

    /**
     * This creates an adapter for a {@link earthnewmedia.model.ImageMetadata}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createImageMetadataAdapter() {
        if (imageMetadataItemProvider == null) {
            imageMetadataItemProvider = new ImageMetadataItemProvider(this);
        }

        return imageMetadataItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link earthnewmedia.model.AudioMetadata} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected AudioMetadataItemProvider audioMetadataItemProvider;

    /**
     * This creates an adapter for a {@link earthnewmedia.model.AudioMetadata}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createAudioMetadataAdapter() {
        if (audioMetadataItemProvider == null) {
            audioMetadataItemProvider = new AudioMetadataItemProvider(this);
        }

        return audioMetadataItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link earthnewmedia.model.VideoMetadata} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected VideoMetadataItemProvider videoMetadataItemProvider;

    /**
     * This creates an adapter for a {@link earthnewmedia.model.VideoMetadata}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createVideoMetadataAdapter() {
        if (videoMetadataItemProvider == null) {
            videoMetadataItemProvider = new VideoMetadataItemProvider(this);
        }

        return videoMetadataItemProvider;
    }

    /**
     * This returns the root adapter factory that contains this factory. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public ComposeableAdapterFactory getRootAdapterFactory() {
        return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
    }

    /**
     * This sets the composed adapter factory that contains this factory. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
        this.parentAdapterFactory = parentAdapterFactory;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean isFactoryForType(Object type) {
        return supportedTypes.contains(type) || super.isFactoryForType(type);
    }

    /**
     * This implementation substitutes the factory itself as the key for the
     * adapter. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter adapt(Notifier notifier, Object type) {
        return super.adapt(notifier, this);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object adapt(Object object, Object type) {
        if (isFactoryForType(type)) {
            Object adapter = super.adapt(object, type);
            if (!(type instanceof Class<?>) || (((Class<?>) type).isInstance(adapter))) {
                return adapter;
            }
        }

        return null;
    }

    /**
     * This adds a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void addListener(INotifyChangedListener notifyChangedListener) {
        changeNotifier.addListener(notifyChangedListener);
    }

    /**
     * This removes a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void removeListener(INotifyChangedListener notifyChangedListener) {
        changeNotifier.removeListener(notifyChangedListener);
    }

    /**
     * This delegates to {@link #changeNotifier} and to
     * {@link #parentAdapterFactory}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void fireNotifyChanged(Notification notification) {
        changeNotifier.fireNotifyChanged(notification);

        if (parentAdapterFactory != null) {
            parentAdapterFactory.fireNotifyChanged(notification);
        }
    }

    /**
     * This disposes all of the item providers created by this factory. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void dispose() {
        if (userItemProvider != null)
            userItemProvider.dispose();
        if (credentialsItemProvider != null)
            credentialsItemProvider.dispose();
        if (memberAttributeItemProvider != null)
            memberAttributeItemProvider.dispose();
        if (libraryItemProvider != null)
            libraryItemProvider.dispose();
        if (libraryItemItemProvider != null)
            libraryItemItemProvider.dispose();
        if (commentItemProvider != null)
            commentItemProvider.dispose();
        if (articleMetadataItemProvider != null)
            articleMetadataItemProvider.dispose();
        if (imageMetadataItemProvider != null)
            imageMetadataItemProvider.dispose();
        if (audioMetadataItemProvider != null)
            audioMetadataItemProvider.dispose();
        if (videoMetadataItemProvider != null)
            videoMetadataItemProvider.dispose();
    }

}
